'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII  433 MHZ TRX EVALUATION DEMO  V2.20    IIIIIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' Erstversion: CONRAD ELECRONIC Feb.02 (DH)
' nderung:    V2.20 Dirk Ottensmeyer Mai 05
'---------------- Kurzbeschreibung -------------------------------------
'Dies ist eine kleine Demo zum Senden von Daten zu einem weiteren TRX 433.
'Das Programm beschrnkt sich auf das zyklische (1 s) Senden eines festen
'Datenrahmens mit einem Byte als laufender Zhler.
'Das Programm ist auf C-CONTROL I mit Applicationboard zugeschnitten.
'Da der Treiber auch zur C-CONTROL I STATION passt, kann das Programm auch
'darauf laufen, die Ausgaben auf das LCD sind dann aber natrlich berflssig.
'Das Programm sendet Daten, die mit trx433_8_rx.bas (C-CONTROL I) oder
'[ccrp5_]trx433_8_rx.c2 (C-CONTROL II) angezeigt werden knnen.

' PORT 9-15 ->LCD
' PORT 1 = DATA/RF DATA RECEIVED
' PORT 2 = CLOCK
' PORT 3 = ACKN
'
'********************************************************************

' Konstanten-Definitionen:

define MIN_POWER   50 'Fr TRX POWER_MIN
define TX_ADDR    255 'Senderadresse fr Control-TRX
define CONTROL_CODE 0 'Kontrollcode fr Control-TRX
define MODE_CTRL  255 'Kontrollmodus fr Control-TRX

' Variablen-Definitionen:

' TRX Benutzer Interface
define MODE     byte[1]
define SDATA1   byte[2]
define SDATA0   byte[3]
define COMMAND  byte[4]
define SADDRESS byte[5]

define DATA0    byte[2]
define DATA1    byte[3]
define DATA2    byte[4]
define DATA3    byte[5]
define DATA4    byte[6]
define DATA5    byte[7]
define DATA6    byte[8]
define ADDRESS  byte[9]

define TRX_BYTE byte[5] 'DATA3
define TRX_INT  word[3] 'DATA3/4

define RX_ERROR byte[10] 'Empfangsfehler [on/off]

' LCD-Interface
define lcd_buf  byte[11]
define lcd_param byte[12]

' Binr - Dezimal Umwandlung
define hunderter byte[13]
define zehner   byte[14]
define einer    byte[15]
define value    byte[16]

' Digitalport-Definitionen:
define DATA     port[1]  ' TRX 433 DATA  (blau)
define CLOCK    port[2]  ' TRX 433 CLOCK (gelb)
define ACKN     port[3]  ' TRX 433 ACKN  (grn)

' LCD-Port
define lcd_port byteport[2]
define lcd_rw   port[13]
define lcd_rs   port[14]
define lcd_e    port[15]

' TRX 433 Treiber Aufrufe:
define SEND     &H0101
define RECEIVE  &H017D

'********************************************************************

' Beginn Initialisierungen:

gosub LCD_INIT
gosub Message

' Initialisierung TRX 433
gosub RESET_TRX         'Reset
gosub POWER_MAX:pause 2 'Max. Sendeleistung
pause 50:gosub LCD_CLS

'********************************************************************

' Beginn Hauptprogramm:

'Gerteadresse 133 festlegen
SDATA0=133:gosub SET_DEVICE_ADDRESS
'Gerteadresse lesen und anzeigen
gosub GET_STATUS:beep 368,10,1
gosub LCD_CLS
lcd_param = &H44 : gosub LCD_WRITECHAR    'D
lcd_param = &H45 : gosub LCD_WRITECHAR    'E
lcd_param = &H56 : gosub LCD_WRITECHAR    'V
lcd_param = &H41 : gosub LCD_WRITECHAR    'A
lcd_param = &H44 : gosub LCD_WRITECHAR    'D
lcd_param = &H44 : gosub LCD_WRITECHAR    'D
lcd_param = &H52 : gosub LCD_WRITECHAR    'R
lcd_param = &H20 : gosub LCD_WRITECHAR    '
value=SDATA1:gosub convert:pause 150:gosub LCD_CLS
'Schleife zum Senden von Frames
#snd
zehner=zehner+1
DATA0=0:DATA1=1:DATA2=2:DATA3=3:DATA4=4:DATA5=5:DATA6=zehner
gosub LCD_CLS
lcd_param = &H54 : gosub LCD_WRITECHAR    'T
lcd_param = &H58 : gosub LCD_WRITECHAR    'X
lcd_param = &H20 : gosub LCD_WRITECHAR    '
value=DATA6:gosub convert:zehner=DATA6
lcd_param = &H20 : gosub LCD_WRITECHAR    '
lcd_param = &H20 : gosub LCD_WRITECHAR    '
ADDRESS=100 'Empfngeradresse
sys SEND:pause 50:goto snd

'********************************************************************

' Meldung

 #Message
 gosub LCD_CLS
 lcd_param = 1 : gosub LCD_GOTOLINE
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H54 : gosub LCD_WRITECHAR    'T
 lcd_param = &H52 : gosub LCD_WRITECHAR    'R
 lcd_param = &H58 : gosub LCD_WRITECHAR    'X
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H34 : gosub LCD_WRITECHAR    '4
 lcd_param = &H33 : gosub LCD_WRITECHAR    '3
 lcd_param = &H33 : gosub LCD_WRITECHAR    '3
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = 2 : gosub LCD_GOTOLINE
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H54 : gosub LCD_WRITECHAR    'T
 lcd_param = &H52 : gosub LCD_WRITECHAR    'R
 lcd_param = &H58 : gosub LCD_WRITECHAR    'X
 lcd_param = &H20 : gosub LCD_WRITECHAR    '
 lcd_param = &H44 : gosub LCD_WRITECHAR    'D
 lcd_param = &H45 : gosub LCD_WRITECHAR    'E
 lcd_param = &H4D : gosub LCD_WRITECHAR    'M
 lcd_param = &H4F : gosub LCD_WRITECHAR    'O
 return

'********************************************************************

' LCD-Interface:

#LCD_INIT
' alle ports 0
  lcd_port = off

' 8-Bit-Modus aktivieren
  lcd_param=&H38 : gosub LCD_WRITECMD

' mit 8-Bit-Command in 4-Bit-Modus umschalten
  lcd_port=&B00000010
  tog lcd_e
  tog lcd_e

' ab jetzt 4-Bit-Modus
  lcd_param = &H28 : gosub LCD_WRITECMD
  lcd_param = &H0C : gosub LCD_WRITECMD

' Display loeschen
#LCD_CLS
  lcd_param = &H02 : gosub LCD_WRITECMD
  lcd_param = &H01 : gosub LCD_WRITECMD
return

' Zeilenwechsel
#LCD_GOTOLINE
  if lcd_param = 1 then lcd_param = &H80
  if lcd_param = 2 then lcd_param = &HC0
  goto LCD_WRITECMD

' LCD-Kommando
#LCD_WRITECMD
  lcd_buf = off
  goto LCD_WRITE

' Zeichenausgabe
#LCD_WRITECHAR
  lcd_buf = &B00100000

' Kommando oder Zeichen an Display senden
#LCD_WRITE
  lcd_port = lcd_buf or (lcd_param shr 4) ' Hi-Nibble
  tog lcd_e
  tog lcd_e
  lcd_port = lcd_buf or (lcd_param and &H0F)  ' Lo-Nibble
  tog lcd_e
  tog lcd_e
return

'********************************************************************

' Binr - Dezimal Umwandlung:
#convert
 hunderter=value/100
 if hunderter>0 then lcd_param=hunderter+&H30 else lcd_param=&H20
 gosub lcd_writechar
 'zehner abfragen
 zehner=(value-(hunderter*100))/10
 lcd_param=zehner+&H30
 gosub lcd_writechar
 'einer abfragen
 einer=value-(hunderter*100)-(zehner*10)
 lcd_param=einer+&H30
 gosub lcd_writechar
 return

'********************************************************************

' TRX 433 Interface:

' 8 Byte RF-Frame senden
#SEND_RF
#SEND_RF8
MODE=0:sys SEND:return
' 8 Byte RF-Frame empfangen
#RECEIVE_RF
#RECEIVE_RF8
MODE=2:SADDRESS=0:COMMAND=13:sys SEND:pause 1
MODE=0:sys RECEIVE:return
' TRX Status lesen
#GET_STATUS
MODE=2:SADDRESS=0:COMMAND=0:sys SEND:sys RECEIVE
return 'Gerteadresse=SDATA1
' Kanal 0..4 (aus SDATA0) einstellen
#SET_CH
MODE=2:SADDRESS=0:COMMAND=7:sys SEND:return
' Kanal 0 einstellen
#CH0_ON
MODE=2:SADDRESS=0:COMMAND=7:SDATA0=0:sys SEND:return
' Kanal 1 einstellen
#CH1_ON
MODE=2:SADDRESS=0:COMMAND=7:SDATA0=1:sys SEND:return
' Kanal 2 einstellen
#CH2_ON 'Standard!
MODE=2:SADDRESS=0:COMMAND=7:SDATA0=2:sys SEND:return
' Kanal 3 einstellen
#CH3_ON
MODE=2:SADDRESS=0:COMMAND=7:SDATA0=3:sys SEND:return
' Kanal 4 einstellen
#CH4_ON
MODE=2:SADDRESS=0:COMMAND=7:SDATA0=4:sys SEND:return
' Sendeleistung 0..255 (aus SDATA0) einstellen
#SET_POWER
MODE=2:SADDRESS=0:COMMAND=6:sys SEND:return
' Sendeleistung -43 dBm einstellen
#POWER0
MODE=2:SADDRESS=0:COMMAND=6:SDATA0=0:sys SEND:return
' Sendeleistung -20 dBm einstellen
#POWER1
MODE=2:SADDRESS=0:COMMAND=6:SDATA0=1:sys SEND:return
' Sendeleistung -15 dBm einstellen
#POWER2
MODE=2:SADDRESS=0:COMMAND=6:SDATA0=2:sys SEND:return
' Sendeleistung -10 dBm einstellen
#POWER3
MODE=2:SADDRESS=0:COMMAND=6:SDATA0=4:sys SEND:return
' Sendeleistung -5 dBm einstellen
#POWER4
MODE=2:SADDRESS=0:COMMAND=6:SDATA0=8:sys SEND:return
' Sendeleistung 0 dBm einstellen
#POWER5 'Standard!
MODE=2:SADDRESS=0:COMMAND=6:SDATA0=15:sys SEND:return
' Sendeleistung +5 dBm einstellen
#POWER6
MODE=2:SADDRESS=0:COMMAND=6:SDATA0=111:sys SEND:return
' Max. Sendeleistung +10 dBm einstellen
#POWER7
#POWER_MAX
MODE=2:SADDRESS=0:COMMAND=6:SDATA0=255:sys SEND:return
#POWER_MID
SDATA0=100:goto SET_POWER
#POWER_MIN
SDATA0=MIN_POWER:goto SET_POWER
' Reset TRX
#RESET_TRX
MODE=2:SADDRESS=0:COMMAND=8:sys SEND:pause 10
MODE=0:return
' CF-Framelnge 4 Byte whlen
#FRAME4
MODE=2:return
' RF-Framelnge 8 Byte einstellen
#FRAME8
MODE=2:SADDRESS=0:COMMAND=4:sys SEND
MODE=0:return
' RF-Framelnge 16 Byte einstellen
#FRAME16
MODE=2:SADDRESS=0:COMMAND=5:sys SEND
MODE=1:return
' Device Address 0..255 (aus SDATA0) einstellen
#SET_DEVICE_ADDRESS
MODE=2:SADDRESS=0:COMMAND=3:sys SEND
return
' Prambellnge (aus SDATA0) einstellen
#SET_PREAMBLE
MODE=2:SADDRESS=0:COMMAND=14:sys SEND
return

' RF-Buffer leeren
#FLUSH
if DATA=on then gosub RECEIVE_RF
return
' Warten (TRX_INT * 20ms) bis Daten gelesen werden knnen
#WAIT4READY
TRX_INT=TRX_INT+timer
#WAITING
if DATA=on then goto DATA_VALID
if TRX_INT<>timer then goto WAITING
TRX_INT=off:return 'Timeout
#DATA_VALID
TRX_INT=on:return  'Daten knnen gelesen werden
' Untere FSK Frequenz einstellen
#FSK_LO
MODE=2:SADDRESS=0:COMMAND=12:SDATA0=0:sys SEND:return
' Obere FSK Frequenz einstellen
#FSK_HI
MODE=2:SADDRESS=0:COMMAND=12:SDATA0=1:sys SEND:return
' Sender einschalten
#TX_ON
MODE=2:SADDRESS=0:COMMAND=9:sys SEND
return
' Empfnger einschalten
#RX_ON
MODE=2:SADDRESS=0:COMMAND=10:sys SEND
return
' Audio 1k senden
#TX_AUDIO1K
MODE=2:SADDRESS=0:COMMAND=1:SDATA0=&H11:SDATA1=&H16:sys SEND
return
' Audio 2k senden
#TX_AUDIO2K
MODE=2:SADDRESS=0:COMMAND=1:SDATA0=&H11:SDATA1=&H26:sys SEND
return

' Erweiterte 8-Byte-Sende-/Empfangsfunktionen
'  (Siehe C-Control II Modul "trx.c2" ab V2.2 [CC2Net.de]!)
' Kontrollframe senden/empfangen
'  Kontroll-Modus (1..19) in DATA0, Parameter in DATA1
'  Mgliche Werte fr DATA0:
'   Sendeleistung:           1   Direktkontrolle:   10
'   Kanal:                   2   Sendewiederholung: 11
'   Prambel:                3   Sendeanforderung:  12
'   Gerteadresse:           4   (Kontrollcode:     13)
'   Framelnge:              5
'   Informationsanforderung: 6
'  Nur fr Direktkontrolle (DATA0=10):
'   DATA4="COMMAND", DATA5="SDATA0", DATA6="SDATA1"
#SEND_CONTROL 'ADDRESS=Empfngeradresse
DATA3=CONTROL_CODE 'Kontrollcode
DATA2=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
if DATA0=6 then goto Infoempfang
goto SEND_RF8
#Infoempfang
RX_ERROR=on
if DATA1=0 then goto Statusempfang
if DATA1=1 then goto Datumempfang
if DATA1=2 then goto Zeitempfang
goto SEND_RF8
#Statusempfang
gosub SEND_RF8
TRX_INT=14:gosub WAIT4READY 'max. 280 ms auf Daten warten
if TRX_INT=on then goto RECEIVE_STATUS
return
#Datumempfang
gosub SEND_RF8
TRX_INT=14:gosub WAIT4READY
if TRX_INT=on then goto RECEIVE_DATE
return
#Zeitempfang
gosub SEND_RF8
TRX_INT=14:gosub WAIT4READY
if TRX_INT=on then goto RECEIVE_TIME
return

#RECEIVE_CONTROL
gosub RECEIVE_RF
if MODE_CTRL=0 then goto Echo
RX_ERROR=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
if DATA2=RX_ERROR and DATA3=CONTROL_CODE then goto FrameOK
RX_ERROR=DATA0
#KontrollFehler
DATA0=RX_ERROR:RX_ERROR=on
return
#Echo
pause 9:gosub SEND_RF8:RX_ERROR=0
goto KontrollFehler
#FrameOK
RX_ERROR=DATA0
if MODE_CTRL=255 then goto ModusOK
if DATA0<>MODE_CTRL then goto KontrollFehler
#ModusOK
if TX_ADDR=255 or ADDRESS=TX_ADDR then goto Kontrolle
goto KontrollFehler
#Kontrolle
if DATA0=1 then goto Sendeleistung1
if DATA0=2 then goto Kanal2
if DATA0=3 then goto Praeambel3
if DATA0=4 then goto Adresse4
if DATA0=5 then goto Framelaenge5
if DATA0=6 then goto Info6
if DATA0=10 then goto Direktkontrolle10
if DATA0=11 or DATA0=12 then goto KontrolleOK
if DATA0=13 then goto Kontrollcode13
goto KontrollFehler
#Sendeleistung1
gosub SET_POWER '!!! SDATA0=DATA1 (byte[3]) !!!
goto KontrolleOK
#Kanal2
if DATA1>4 then goto KontrollFehler
gosub SET_CH
goto KontrolleOK
#Praeambel3
gosub SET_PREAMBLE
goto KontrolleOK
#Adresse4
gosub SET_DEVICE_ADDRESS
goto KontrolleOK
#Framelaenge5
if DATA1<>8 then goto KontrollFehler
gosub FRAME8:goto KontrolleOK
#Info6
if DATA1=0 then goto Status
if DATA1=1 then goto Datum
if DATA1=2 then goto Zeit
goto KontrollFehler
#Status
DATA3=15:DATA4=2:DATA5=10:DATA6=8 'Standardwerte!
pause 7:gosub SEND_STATUS
goto KontrolleOK
#Datum
pause 7:gosub SEND_DATE
goto KontrolleOK
#Zeit
pause 7:gosub SEND_TIME
goto KontrolleOK
#Direktkontrolle10
if DATA4>14 then goto KontrollFehler
SADDRESS=0:COMMAND=DATA4:SDATA0=DATA5:SDATA1=DATA6
if COMMAND=0 or COMMAND=5 or COMMAND=13 then goto KontrollFehler
MODE=2:sys SEND 'CF-Frame senden
if COMMAND=4 or COMMAND=8 then MODE=0
goto KontrolleOK
#Kontrollcode13
'CONTROL_CODE=DATA1 'CONTROL_CODE muss als Variable definiert sein!
goto KontrollFehler '<- ggf. entfernen!
#KontrolleOK
DATA0=RX_ERROR:RX_ERROR=off
return 'Modus 11/12: Sendewiederholung/-anforderung=DATA1,
       'Empfangsfehler=RX_ERROR

' Status senden/empfangen
'  DATA3=Sendeleistung, DATA4=Kanal, DATA5=Prambel,
'  DATA6=Framelnge
#SEND_STATUS 'ADDRESS=Empfngeradresse
DATA0=20 'MODE_STATUStrx
DATA1=0  'Frame Nr. 0
DATA2=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
goto SEND_RF8

#RECEIVE_STATUS
gosub RECEIVE_RF
RX_ERROR=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
if DATA0=20 and DATA1=0 and DATA2=RX_ERROR then RX_ERROR=off else RX_ERROR=on
return 'Sendeleistung=DATA3, Kanal=DATA4, Prambel=DATA5,
       'Framelnge=DATA6, Empfangsfehler=RX_ERROR

' Byte (TRX_BYTE) senden/empfangen
#SEND_BYTE 'ADDRESS=Empfngeradresse
DATA0=21 'MODE_BYTEtrx
DATA1=0  'Frame Nr. 0
DATA2=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
goto SEND_RF8

#RECEIVE_BYTE
gosub RECEIVE_RF
RX_ERROR=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
if DATA0=21 and DATA1=0 and DATA2=RX_ERROR then RX_ERROR=off else RX_ERROR=on
return 'Byte=TRX_BYTE, Empfangsfehler=RX_ERROR

' Integer (TRX_INT) senden/empfangen
#SEND_INT 'ADDRESS=Empfngeradresse
DATA0=22 'MODE_INTtrx
DATA1=DATA3:DATA3=DATA4:DATA4=DATA1 'LO/HI-Byte tauschen
DATA1=0  'Frame Nr. 0
DATA2=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
goto SEND_RF8

#RECEIVE_INT
gosub RECEIVE_RF
RX_ERROR=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
if DATA0=22 and DATA1=0 and DATA2=RX_ERROR then RX_ERROR=off else RX_ERROR=on
DATA1=DATA3:DATA3=DATA4:DATA4=DATA1:DATA1=0 'LO/HI-Byte tauschen
return 'Integer=TRX_INT, Empfangsfehler=RX_ERROR

' Datum senden/empfangen
#SEND_DATE 'ADDRESS=Empfngeradresse
DATA0=26 'MODE_DATEtrx
DATA1=0  'Frame Nr. 0
DATA2=year 'Jahr funktioniert so bis 2099!
DATA3=208+DATA2:if DATA2>47 then DATA3=DATA2-48
DATA4=7:if DATA2>47 then DATA4=8
DATA5=month
DATA6=day
DATA2=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
goto SEND_RF8

#RECEIVE_DATE
gosub RECEIVE_RF
RX_ERROR=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
if DATA0=26 and DATA1=0 and DATA2=RX_ERROR then goto DatumOK
RX_ERROR=on
return
#DatumOK
year=((DATA4*256+DATA3) MOD 100)
month=DATA5
day=DATA6
RX_ERROR=off
return 'Empfangsfehler=RX_ERROR

' Uhrzeit senden/empfangen
#SEND_TIME 'ADDRESS=Empfngeradresse
DATA0=27 'MODE_TIMEtrx
DATA1=0  'Frame Nr. 0
DATA3=hour
DATA4=minute
DATA5=second
DATA6=0  'CC1: 0, CC2: Sommerzeitflag (0=Normalzeit)
DATA2=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
goto SEND_RF8

#RECEIVE_TIME
gosub RECEIVE_RF
RX_ERROR=DATA0+DATA1+DATA3+DATA4+DATA5+DATA6 'Checksumme
if DATA0=27 and DATA1=0 and DATA2=RX_ERROR then goto ZeitOK
RX_ERROR=on
return
#ZeitOK
hour=DATA3
minute=DATA4
second=DATA5
RX_ERROR=off
return 'Empfangsfehler=RX_ERROR

'********************************************************************

' Gertetreiber fr TRX 433 laden:
syscode "driv433.s19"
